module Gallus
  class Level
    include Comparable

    def self.all
      @all ||= []
    end

    def self.each(&block)
      self.all.each(&block)
    end

    def self.[](name)
      const_get(name.to_s)
    end

    attr_reader :name, :id

    def initialize(name, id)
      @name, @id = name.to_s, id

      self.class.const_set(@name, self)
      self.class.all << self
    end

    def <=>(other)
      self.id <=> other.id
    rescue => err
      return nil
    end

    def to_s
      name
    end

    new :TRACE, 1
    new :DEBUG, 2
    new :INFO,  3
    new :WARN,  4
    new :ERROR, 5
  end
end
