module Gallus
  module Output
    class Stream
      def initialize(stream, format)
        @mutex = Mutex.new
        @stream, @format = stream, format
      end

      def call(event)
        @mutex.synchronize { call!(event) }
      end

      def call!(event)
        @stream.write(@format.call(event) + "\n")
      end
    end
  end
end
