module Gallus
  # Public: Similarly to Perfume::Logging no point to initialize global logger for your
  # modules/packages. Include this mixin to define LOGGER constant and log class method
  # shortcut.
  #
  # Often used practice is to define such top level logger as a parent with default
  # outputters, formatters, log level, etc.
  module PackageLogging
    def self.included(klass)
      klass.const_set(:LOG, ::Gallus::Log.configure(klass.name))
      klass.extend(ClassMethods)
    end

    module ClassMethods
      def log
        const_get(:LOG)
      end
    end
  end
end
