module Gallus
  class Repository
    PARENT_DELIMITER = '::'

    @mutex = Mutex.new

    def self.all
      @all ||= {}
    end

    def self.find_parent(name)
      parent, name = nil, name.dup

      while parent.nil?
        name = name.split(PARENT_DELIMITER)[0..-2].join(PARENT_DELIMITER)
        parent = all[name]
        break if name.empty?
      end

      parent
    end

    def self.delete_with_children(name)
      @mutex.synchronize do
        all.keys.each { |k| all.delete(k) if k.start_with?(name + PARENT_DELIMITER) }
        all.delete(name)
      end
    end

    def self.get_or_create_logger(name, &block)
      name, log = name.to_s, nil

      @mutex.synchronize do
        unless log = all[name]
          all[name] = (log = Class.new(Log).new(find_parent(name), name, &block))
        end
      end

      log
    end
  end
end
