require 'perfume/service'

module Perfume
  # Public: There's often need to exit from the app in a testable and graceful manner.
  # Simple call to Kernel#exit isn't such. This simple wrapper around the Kernel method
  # allows to say goodbye message via service logging as well as status code.
  class Exit < Service
    args :message, :code, :log

    def defaults
      { message: "Exiting...", code: 1 }
    end

    def log
      @log ||= self.class.log
    end

    def call
      log.error(@message)
      Kernel.exit(@code)
    end
  end
end
